#!/bin/bash
#
# packager                          : Frederic Boulet <bipbip> bipbiponlinux~AT~gmail.com
#
# où trouver les sources : http://xinehq.de/
#
# dernières révisions       : 29/05/2007

# ------ Verify Script
if [ "$(id -u)" != "0" ]; then
	echo "This script must be run as root!"
	exit
fi

# ------ Help
if [ "${1}" = "--help" ]; then
	echo \
	"Zenwalk ${0} script:
			--nocleanup	Do NOT Cleanup of Post build and Temporary Repo
			--download	Download the sources
			--help		Displays this help"
	exit
fi

# ------ Credentials
NAME=xine-ui-skins
VERSION=0.1
ARCH=${ARCH:-"i486"}
BUILD=${BUILD:-1}
ZEN=${ZEN:-"48"}
EXT=${EXT:-"tgz"}
REPO=${REPO:-"$(pwd)"}
SOURCE[0]=http://xinehq.de/index.php/force-download/skins/Antares.tar.gz
SOURCE[1]=http://xinehq.de/index.php/force-download/skins/Bambino-Black.tar.gz
SOURCE[2]=http://xinehq.de/index.php/force-download/skins/Bambino-Blue.tar.gz
SOURCE[3]=http://xinehq.de/index.php/force-download/skins/Bambino-Green.tar.gz
SOURCE[4]=http://xinehq.de/index.php/force-download/skins/Bambino-Orange.tar.gz
SOURCE[5]=http://xinehq.de/index.php/force-download/skins/Bambino-Pink.tar.gz
SOURCE[6]=http://xinehq.de/index.php/force-download/skins/Bambino-Purple.tar.gz
SOURCE[7]=http://xinehq.de/index.php/force-download/skins/Bambino-White.tar.gz
SOURCE[8]=http://xinehq.de/index.php/force-download/skins/Bluton.tar.gz
SOURCE[9]=http://xinehq.de/index.php/force-download/skins/CelomaChrome.tar.gz
SOURCE[10]=http://xinehq.de/index.php/force-download/skins/CelomaGold.tar.gz
SOURCE[11]=http://xinehq.de/index.php/force-download/skins/CelomaMdk.tar.gz
SOURCE[12]=http://xinehq.de/index.php/force-download/skins/Centori.tar.gz
SOURCE[13]=http://xinehq.de/index.php/force-download/skins/Crystal.tar.gz
SOURCE[14]=http://xinehq.de/index.php/force-download/skins/Galaxy.tar.gz
SOURCE[15]=http://xinehq.de/index.php/force-download/skins/Keramic.tar.gz
SOURCE[16]=http://xinehq.de/index.php/force-download/skins/KeramicRH8.tar.gz
SOURCE[17]=http://xinehq.de/index.php/force-download/skins/OMS_legacy.tar.gz
SOURCE[18]=http://xinehq.de/index.php/force-download/skins/Polaris.tar.gz
SOURCE[19]=http://xinehq.de/index.php/force-download/skins/Sunset.tar.gz
SOURCE[20]=http://xinehq.de/index.php/force-download/skins/blackslim2.tar.gz
SOURCE[21]=http://xinehq.de/index.php/force-download/skins/caramel.tar.gz
SOURCE[22]=http://xinehq.de/index.php/force-download/skins/cloudy.tar.gz
SOURCE[23]=http://xinehq.de/index.php/force-download/skins/concept.tar.gz
SOURCE[24]=http://xinehq.de/index.php/force-download/skins/gudgreen.tar.gz
SOURCE[25]=http://xinehq.de/index.php/force-download/skins/lcd.tar.gz
SOURCE[26]=http://xinehq.de/index.php/force-download/skins/mp2k.tar.gz
SOURCE[27]=http://xinehq.de/index.php/force-download/skins/mplayer.tar.gz
SOURCE[28]=http://xinehq.de/index.php/force-download/skins/pitt.tar.gz
SOURCE[29]=http://xinehq.de/index.php/force-download/skins/xinetic.tar.gz
SOURCE[30]=http://xinehq.de/index.php/force-download/skins/xinium.tar.gz
CFLAGS=${CFLAGS:-"-O2 -pipe -march=i486 -mtune=i686"}

# ------ Setup
CWD=$(pwd)
TMP=${CWD}/build
PKG=${TMP}/package-${NAME}
# command line options
if [ "${1}" = "--nocleanup" -o "${2}" = "--nocleanup" ]; then
	CLEANUP="0"
else
	CLEANUP="1"
fi
if [ "${1}" = "--download" -o "${2}" = "--download" ]; then
	DOWNLOAD="1"
else
	DOWNLOAD="0"
fi
# build location
if [ ! -d ${TMP} ]; then
	install -d -m700 ${TMP}
fi
# repo location
if [ ! -d ${REPO} ]; then
	install -v -d -m755 ${REPO}
fi

# ------ Slack Desc
install -d -m755 ${PKG}/install
cat > ${PKG}/install/slack-desc << EoF
#      |-----handy-ruler------------------------------------------------------|
${NAME}: xine-ui-skins - skins for xine-ui
${NAME}:
${NAME}:  
${NAME}: skins for xine-ui 
${NAME}:  
${NAME}:   
${NAME}: 
${NAME}:
${NAME}:
${NAME}: 
${NAME}:
EoF

# ------ Retrieve & Decompress
X=0
while [ "${SOURCE[X]}" != "" ]; do
	[ "${DOWNLOAD}" = "1" ] && \
		( $(which wget) -c ${SOURCE[X]} || exit 1 )
	X=$((X + 1))
done

# ------ Build Package
mkdir ${TMP}/skins
install -d -m755 ${PKG}/usr/share/xine/skins/
for file in *.tar.gz; do
	tar zxvf ${file} -C ${TMP}/skins
done
cd ${TMP}/skins
chmod -R 755 ${TMP}/skins
for i in *; do
    mv $i ${PKG}/usr/share/xine/skins/
done

# ------ Zenify
# buildscript
install -d -m755 ${PKG}/usr/src/${NAME}-${VERSION}
install -m755 ${CWD}/${0} ${PKG}/usr/src/${NAME}-${VERSION}/build-${NAME}.sh

# set permissions
chown -R root:root ${PKG}
find ${PKG} -perm 664 -exec chmod 644 {} \;
find ${PKG} -perm 600 -exec chmod 644 {} \;
find ${PKG} -perm 444 -exec chmod 644 {} \;
find ${PKG} -perm 400 -exec chmod 644 {} \;
find ${PKG} -perm 440 -exec chmod 644 {} \;
find ${PKG} -perm 777 -exec chmod 755 {} \;
find ${PKG} -perm 775 -exec chmod 755 {} \;
find ${PKG} -perm 511 -exec chmod 755 {} \;
find ${PKG} -perm 711 -exec chmod 755 {} \;
find ${PKG} -perm 555 -exec chmod 755 {} \;

# ------ Create
cd ${PKG}

# build package
makepkg -l y -c n -p ${REPO}/${NAME}-${VERSION}-${ARCH}-${ZEN}.${BUILD}.${EXT}
# build md5 checksum
( cd ${REPO} ; md5sum ${NAME}-${VERSION}-${ARCH}-${ZEN}.${BUILD}.${EXT} \
	> ${NAME}-${VERSION}-${ARCH}-${ZEN}.${BUILD}.md5 )
# build dep file
( cd ${REPO} ; echo -n "xine-ui" > ${NAME}-${VERSION}-${ARCH}-${ZEN}.${BUILD}.dep)

# ------ Cleanup
if [ "${CLEANUP}" = "1" ]; then
	rm -rf ${TMP}
fi
